
PACKAGE BODY Compression_Parameters IS



  FUNCTION Has_Prefix( Text : IN String; Code : IN String ) RETURN Boolean IS
      Head : Natural := Text'FIRST;
  BEGIN
      WHILE Head IN Text'RANGE AND THEN Text( Head ) = ' ' LOOP
          Head := Head + 1;
      END LOOP;
      RETURN ( ( Text'LAST - Head + 1 ) >= Code'LENGTH ) AND THEN
             ( Text( Head .. Head + Code'LENGTH - 1 ) = Code );
  END Has_Prefix;



  PROCEDURE Validate_Markers( Options : IN Compression_Options ) IS
  BEGIN
      FOR Head IN Options.Markers.List'RANGE LOOP
          EXIT WHEN Head = Options.Markers.List'LAST;
          FOR Tail IN Marker_Index'SUCC( Head ) .. Options.Markers.List'LAST
          LOOP
              IF Memory_Definition_1750a."="
                ( Options.Markers.List( Head ),
                  Options.Markers.List( Tail ) )
              THEN
                  RAISE Invalid_Input;
              END IF;
          END LOOP;
      END LOOP;
  END Validate_Markers;



  FUNCTION Contains_Comment_Prefix( Text : IN String ) RETURN Boolean IS
  BEGIN
      RETURN Has_Prefix( Text, Input_Comment_Prefix );
  END Contains_Comment_Prefix;



  FUNCTION Contains_Code_Separator( Text : IN String ) RETURN Boolean IS
  BEGIN
      RETURN Has_Prefix( Text, Fixed_Code_Separator );
  END Contains_Code_Separator;



  FUNCTION Image( Value : Natural ) RETURN String IS
      Size : CONSTANT := 2;
      Text : CONSTANT String := Natural'IMAGE( Value );
      Head : Natural := Text'FIRST;
  BEGIN
      WHILE Head IN Text'RANGE AND THEN Text( Head ) = ' ' LOOP
          Head := Head + 1;
      END LOOP;
      RETURN String'( 1 .. Size + Head - Text'LAST => ' ' ) &
             Text( Head .. Text'LAST );
  EXCEPTION
      WHEN Standard.Constraint_Error =>
          RETURN Text;
  END Image;



  FUNCTION Image( Index : Marker_Index ) RETURN String IS
  BEGIN
      RETURN Image( Natural( Index ) );
  END Image;



END Compression_Parameters;
