
WITH System;

PACKAGE BODY Direct_Memory_Action IS



  PROCEDURE Perform_Action
    ( Source_Address   : IN Memory_Index;
      Source_List_Head : IN Object_Index;
      Source_List_Tail : IN Object_Index;
      Source_Head      : IN Object_Index;
      Target_Address   : IN Memory_Index;
      Target_List_Head : IN Object_Index;
      Target_List_Tail : IN Object_Index;
      Target_Tail      : IN OUT Object_Index ) IS

      From_Source : Object_Array( Source_List_Head .. Source_List_Tail );
      From_Target : Object_Array( Target_List_Head .. Target_List_Tail );

      FOR From_Source USE AT Convert( Source_Address );
      FOR From_Target USE AT Convert( Target_Address );

  BEGIN
      Operate_On
        ( Source_List => From_Source,
          Source_Head => Source_Head,
          Target_List => From_Target,
          Target_Tail => Target_Tail );
  END Perform_Action;



END Direct_Memory_Action;
