
WITH System;
WITH Unchecked_Conversion;
WITH Memory_Definition_1750a;

PACKAGE Direct_Memory_Action IS

  SUBTYPE Memory_Index IS Memory_Definition_1750a.Memory_Address;


  FUNCTION Convert IS NEW Unchecked_Conversion( Memory_Index, System.Address );
  FUNCTION Convert IS NEW Unchecked_Conversion( System.Address, Memory_Index );



  GENERIC
      TYPE Object_Value IS PRIVATE;
      TYPE Object_Index IS RANGE <>;
      TYPE Object_Array IS ARRAY( Object_Index RANGE <> ) OF Object_Value;
      WITH PROCEDURE Operate_On
        ( Source_List : IN Object_Array;
          Source_Head : IN Object_Index;
          Target_List : IN OUT Object_Array;
          Target_Tail : IN OUT Object_Index ) IS <>;
  PROCEDURE Perform_Action
    ( Source_Address   : IN Memory_Index;
      Source_List_Head : IN Object_Index;
      Source_List_Tail : IN Object_Index;
      Source_Head      : IN Object_Index;
      Target_Address   : IN Memory_Index;
      Target_List_Head : IN Object_Index;
      Target_List_Tail : IN Object_Index;
      Target_Tail      : IN OUT Object_Index );


END Direct_Memory_Action;
