
WITH Unchecked_Conversion;

PACKAGE BODY Memory_Definition_1750a IS

  Byte_Offset : CONSTANT Stored_Address := Stored_Address(Byte_Value'LAST) + 1;


  FUNCTION Primitive_To_Integer IS NEW
      Unchecked_Conversion( Word_Value, Memory_Integer );

  FUNCTION Primitive_To_Word_Value IS NEW
      Unchecked_Conversion( Memory_Integer, Word_Value );



  FUNCTION To_Integer( Value : IN Word_Value ) RETURN Memory_Integer IS
  BEGIN
      RETURN Primitive_To_Integer( Value );
  END To_Integer;



  FUNCTION To_Address( Value : IN Word_Value ) RETURN Stored_Address IS
  BEGIN
      RETURN Stored_Address( Value( 0 ) ) * Byte_Offset +
             Stored_Address( Value( 1 ) );
  END To_Address;



  FUNCTION Convert( Value : IN Memory_Integer ) RETURN Word_Value IS
  BEGIN
      RETURN Primitive_To_Word_Value( Value );
  END Convert;



  FUNCTION Convert( Value : IN Stored_Address ) RETURN Word_Value IS
      Word : Word_Value;
  BEGIN
      Word( 0 ) := Byte_Value( Value / Byte_Offset );
      Word( 1 ) := Byte_Value( Value MOD Byte_Offset );
      RETURN Word;
  END Convert;



END Memory_Definition_1750a;
