
PACKAGE BODY Memory_Hash_Table IS

  TYPE Index_Record;

  TYPE Index_Access IS ACCESS Index_Record;

  TYPE Index_Record IS RECORD
      Data : Memory_Index;
      Link : Index_Access;
      Stop : Boolean := False;
  END RECORD;

  TYPE Locate_Array IS RECORD
      Stop : Boolean := False;
      Head : Index_Access;
  END RECORD;

  TYPE Count_Record IS RECORD
      Size : Memory_Count := 0;
      Link : Index_Access;
  END RECORD;

  Inverse : ARRAY( Memory_Value ) OF Count_Record;



  PROCEDURE Store( Index : IN Memory_Index; Value : IN Memory_Value ) IS
      Link : Index_Access := Inverse( Value ).Link;
      Last : Index_Access;
      Node : Index_Access;
  BEGIN
      LOOP
          IF Link = NULL OR ELSE Index > Link.Data THEN
              Inverse( Value ).Size := Inverse( Value ).Size + 1;
              Node := NEW Index_Record'
                ( Link => Link,
                  Data => Index,
                  Stop => False );
              IF Last = NULL THEN
                  Inverse( Value ).Link := Node;
              ELSE
                  Last.Link := Node;
              END IF;
              EXIT;
          ELSIF Index = Link.Data THEN
              EXIT;
          ELSE
              Last := Link;
              Link := Link.Link;
          END IF;
      END LOOP;
  END Store;



  FUNCTION Found_Linked_List( Value : IN Memory_Value ) RETURN Locate_Array IS
      List : Locate_Array;
  BEGIN
      List.Stop := False;
      List.Head := Inverse( Value ).Link;
      RETURN List;
  END Found_Linked_List;



  FUNCTION Found_Linked_List
    ( Value   : IN Memory_Value;
      Minimum : IN Memory_Index;
      Maximum : IN Memory_Index ) RETURN Locate_Array IS

      List : Locate_Array;
      Link : Index_Access := Inverse( Value ).Link;

  BEGIN
      List.Stop := True;
      WHILE Link /= NULL LOOP
          Link.Stop := False;
          IF Link.Data > Maximum THEN
              NULL;
          ELSIF Link.Data < Minimum THEN
              EXIT;
          ELSIF List.Head = NULL THEN
              List.Head := Link;
          END IF;
          Link := Link.Link;
      END LOOP;
      IF Link /= NULL THEN
          Link.Stop := True;
      END IF;
      RETURN List;
  END Found_Linked_List;



  PROCEDURE Done_Adding_Data IS
  BEGIN
      NULL;
  END Done_Adding_Data;



  PROCEDURE Reset_State_Data IS
  BEGIN
      Inverse := ( OTHERS => ( Size => 0, Link => NULL ) );
  END Reset_State_Data;



  PROCEDURE Reverse_Iterate_Value( Value : IN Memory_Value ) IS
      List : Locate_Array := Found_Linked_List( Value => Value );
      Link : Index_Access := List.Head;
      Quit : Boolean := False;
  BEGIN
      WHILE Link /= NULL LOOP
          EXIT WHEN List.Stop AND THEN Link.Stop;
          Operate( Link.Data, Quit );
          EXIT WHEN Quit;
          Link := Link.Link;
      END LOOP;
  END Reverse_Iterate_Value;



  PROCEDURE Reverse_Iterate_Range
    ( Value   : IN Memory_Value;
      Minimum : IN Memory_Index;
      Maximum : IN Memory_Index ) IS

      List : Locate_Array := 
             Found_Linked_List
               ( Value   => Value,
                 Minimum => Minimum,
                 Maximum => Maximum );
      Link : Index_Access := List.Head;
      Quit : Boolean := False;

  BEGIN
      WHILE Link /= NULL LOOP
          EXIT WHEN List.Stop AND THEN Link.Stop;
          Operate( Link.Data, Quit );
          EXIT WHEN Quit;
          Link := Link.Link;
      END LOOP;
  END Reverse_Iterate_Range;



END Memory_Hash_Table;
