
WITH Compression_Support;
WITH Compression_Instance;

PROCEDURE Set_Parameter_File IS

  -- This procedure helps build the compression parameter file.
  -- The user must supply the number of markers to use,
  -- and the number of bits to add to the representation of
  -- then offset coordinate, and the supplied memory dump file
  -- will be searched for the least frequently used bytes.

  -- The parameter file will then be created for use with
  -- the other utilities:
  --   (1) compression_encode
  --   (2) compression_decode
  --   (3) compression_verify


  PACKAGE Sample_Memory IS

      Source_List : Compression_Instance.Working_Space;
      Source_Head : Compression_Instance.Object_Index := 0;
      Source_Tail : Compression_Instance.Object_Index := 0;

  END Sample_Memory;


BEGIN

  -- Read compression parameters and initialize package states.
  Compression_Support.Initialize_Compression
    ( "Set Parameter File Utility",
      Will_Save_Parameters => True );

  -- Read uncompressed memory image...
  Compression_Support.Load_Memory
    ( Sample_Memory.Source_List,
      Sample_Memory.Source_Head,
      Sample_Memory.Source_Tail );

  -- Write parameter file...
  Compression_Support.Save_Parameters
    ( Sample_Memory.Source_List,
      Sample_Memory.Source_Head,
      Sample_Memory.Source_Tail );

END Set_Parameter_File;
